#property copyright "Houcine Herrati"
#property indicator_chart_window

#property  indicator_buffers 8
extern string TopComment = "<(====_TEV_====)>";
extern color TrendUpColor = Green;
extern color TrendDownColor = Red;

color          FiboColour=Black;  
double         SwingHigh, SwingLow;
double         high, low;
double         Entry, TP1, TP2, TP3;
double         extent = SwingHigh - SwingLow;

double f_1[];
double f_2[];
double f_3[];
double f_4[];
double f_5[];
double f_6[];
double f_7[];


datetime today     = iTime(NULL, PERIOD_D1, 0);
int      iToday    = iBarShift(NULL, 0, today),
         iTodayHigh = Highest(NULL,0,MODE_HIGH, iToday+1, 0), // or not incl. 0 bar: ..iToday, 1)
         iTodayLow = Lowest(NULL,0,MODE_LOWER, iToday+1, 0);
         
         
void DeleteAllObjects()
{
   int objs = ObjectsTotal();
   string name;
   for(int cnt=ObjectsTotal()-1;cnt>=0;cnt--)
   {
      name=ObjectName(cnt);
      if (StringFind(name,"V_",0)>-1) ObjectDelete(name);
      if (StringFind(name,"H_",0)>-1) ObjectDelete(name);
      if (StringFind(name,"f_",0)>-1) ObjectDelete(name);
      if (StringFind(name,"Fibo",0)>-1) ObjectDelete(name);
      if (StringFind(name,"trend",0)>-1) ObjectDelete(name);
      WindowRedraw();
   }
}

int init()
  {
  DeleteAllObjects();
  SetIndexBuffer(0,f_1);
  SetIndexBuffer(1,f_2);
  SetIndexBuffer(2,f_3);
  SetIndexBuffer(3,f_4);
  SetIndexBuffer(4,f_5);
  SetIndexBuffer(5,f_6);
  SetIndexBuffer(6,f_7);
   return(0);
  }

int deinit()
  {
   DeleteAllObjects();
   return(0);
  }

 void GetSwing()
{
   SwingHigh = iHigh(Symbol(),PERIOD_D1,0);
   SwingLow = iLow(Symbol(),PERIOD_D1,0);
   CalculateTradeLevels();  
}
 

void CalculateTradeLevels()
{  
   DeleteAllObjects();
   high = SwingHigh;
   low = SwingLow;
   
   int i = 0;
   
   if (iTodayHigh>iTodayLow && SwingHigh>SwingLow)
      {
      for(i = 0; i < 500; i++)
      {
         f_1[i] = high;
         f_2[i] = NormalizeDouble(SwingLow + (extent * 1.41 / 100), Digits); 
         f_3[i] = NormalizeDouble(SwingLow + (extent * 28.2 / 100), Digits); 
         f_4[i]= NormalizeDouble(SwingLow + (extent * 41.4 / 100), Digits); 
         f_5[i] = NormalizeDouble(SwingLow + (extent * 64.2 / 100), Digits); 
         f_6[i] = low;
      }
   }else{
      for(i = 0; i < 500; i++)
      {
         f_1[i] = high;
         f_1[i] = NormalizeDouble(SwingHigh - (extent * 1.41 / 100), Digits); 
         f_1[i] = NormalizeDouble(SwingHigh - (extent * 28.2 / 100), Digits); 
         f_1[i] = NormalizeDouble(SwingHigh - (extent * 41.4 / 100), Digits); 
         f_1[i] = NormalizeDouble(SwingHigh - (extent * 64.2 / 100), Digits);
         f_1[i] = low;
      }
   }
     
   if (iTodayHigh>iTodayLow && SwingHigh>SwingLow)
   {
      WindowRedraw();
      FiboColour = TrendDownColor;     
   }
   else{
      WindowRedraw();
      FiboColour = TrendUpColor;      
   } 
}  
   
void DrawFib()
{

      datetime OpenTime, CloseTime;
      
      
      OpenTime = iTime(NULL, PERIOD_D1, 0);
      CloseTime = iTime(NULL, PERIOD_D1, 0);
      
      if (iTodayHigh>iTodayLow && SwingHigh>SwingLow)
      {         
         ObjectCreate("Fibo",OBJ_FIBO,0,OpenTime,SwingHigh,CloseTime,SwingLow);
         ObjectSet("Fibo", OBJPROP_COLOR, FiboColour);
         ObjectSet("Fibo", OBJPROP_LEVELCOLOR, FiboColour);
         ObjectSet("Fibo", OBJPROP_WIDTH, 1);
         ObjectSet("Fibo", OBJPROP_FIBOLEVELS, 6);     
         ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+0, 0);
         ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+1, 0.141);
         ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+2, 0.282);
         ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+3, 0.414);
         ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+4, 0.642);
         ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+5, 1);

         ObjectSetFiboDescription("Fibo", 0, "  %$ -" + " (0)");
         ObjectSetFiboDescription("Fibo", 1, "  %$ -" + " (1.41)");
         ObjectSetFiboDescription("Fibo", 2, "  %$ -" + " (2.82)");
         ObjectSetFiboDescription("Fibo", 3, "  %$ -" + " (41.4)");
         ObjectSetFiboDescription("Fibo", 4, "  %$ -" + " (64.2)");
         ObjectSetFiboDescription("Fibo", 5, "  %$ -" + " (100)");
       }else{
  
         ObjectCreate("Fibo",OBJ_FIBO,0,OpenTime,SwingLow,CloseTime,SwingHigh);
         ObjectSet("Fibo", OBJPROP_COLOR, FiboColour);
         ObjectSet("Fibo", OBJPROP_LEVELCOLOR, FiboColour);
         ObjectSet("Fibo", OBJPROP_WIDTH, 1);
         ObjectSet("Fibo", OBJPROP_FIBOLEVELS, 6);     
         ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+5, 0);
         ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+4, 0.141);
         ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+3, 0.282);
         ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+2, 0.414);
         ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+1, 0.642);
         ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+0, 1);
         ObjectSetFiboDescription("Fibo", 5, "  %$ -" + " (0)");
         ObjectSetFiboDescription("Fibo", 4, "  %$ -" + " (1.41)");
         ObjectSetFiboDescription("Fibo", 3, "  %$ -" + " (2.82)");
         ObjectSetFiboDescription("Fibo", 2, "  %$ -" + " (41.4)");
         ObjectSetFiboDescription("Fibo", 1, "  %$ -" + " (64.2)");
         ObjectSetFiboDescription("Fibo", 0, "  %$ -" + " (100)");
          
  }   
}


int start()
  { 
  GetSwing();
  CalculateTradeLevels(); 
  DrawFib(); 
  return(0);
  }
  
  